From 631e4ef632ddddafc6a0f58e7ead6b0be6d6f830 Mon Sep 17 00:00:00 2001
From: Ryan Pavlik <rpavlik@iastate.edu>
Date: Fri, 28 Oct 2011 10:05:35 -0500
Subject: [PATCH 27/43] dix/registry.c: Free old memory upon realloc failure

---
 dix/registry.c |   10 ++++++++--
 1 files changed, 8 insertions(+), 2 deletions(-)

diff --git a/dix/registry.c b/dix/registry.c
index ba588c4..6505fc4 100644
--- a/dix/registry.c
+++ b/dix/registry.c
@@ -67,8 +67,14 @@ static int double_size(void *p, unsigned n, unsigned size)
 	s = 0;
 	n = f = BASE_SIZE * size;
     }
-
-    *ptr = realloc(*ptr, n);
+	{
+	    char * newptr = realloc(*ptr, n);
+	    if (!newptr) {
+	    	free(*ptr);
+	    }
+	    *ptr = newptr;
+	}
+    
     if (!*ptr) {
 	dixResetRegistry();
 	return FALSE;
-- 
1.7.7.1

